/**********************************************/
/* insertion des groupes de droits par défaut */
/**********************************************/
ALTER TABLE groupes_droits ALTER COLUMN libelle TYPE varchar(50);
ALTER TABLE groupes_droits ALTER COLUMN droits TYPE varchar(1500);

delete from groupes_droits where id in (1,2,3,4,5,6,7,8,9,10,21,22,23,31);
insert into groupes_droits values (1,'Lecture', '[''etabs.get_types'', ''etabs.get_etab'', ''etabs.get_libelle_etab'',''etabs.rech_etab'', ''services.get_service_installe'', ''services.get_service'', ''services.get_service_module'', ''serveurs.fichiers_zephir'', ''serveurs.get_serveur_perms'', ''modules.get_variante_perms'',  ''serveurs.global_status'', ''serveurs.get_dico'', ''serveurs.get_config'', ''serveurs.get_serveur'', ''serveurs.get_log'', ''serveurs.serveurs_etab'', ''serveurs.agents_status'', ''serveurs.get_measure'', ''serveurs.get_status'', ''serveurs.groupe_serveur'', ''serveurs.get_conf_uucp'', ''serveurs.get_file_content'', ''modules.get_module'', ''modules.get_mod_dict'', ''modules.get_vars'', ''modules.get_variante'', ''modules.fichiers_variante'', ''modules.get_var_file'', ''modules.get_dico'', ''uucp.get_checksum'', ''serveurs.get_groupes'', ''get_user'', ''serveurs.get_groups'', ''get_permissions'', ''get_restrictions'', ''user_group'', ''edit_user'', ''get_stats'', ''serveurs.groupe_reload'', ''save_key'', ''serveurs.get_bastion'', ''serveurs.save_group'', ''serveurs.del_group'', ''serveurs.edit_group'', ''serveurs.check_backup'', ''serveurs.check_groupes'', ''serveurs.check_serveurs'', ''serveurs.get_locks'', ''serveurs.get_alertes'', ''serveurs.get_migration_status'', ''maj_client'', ''uucp.get_actions'', ''serveurs.get_maj_infos'', ''uucp.sphynx_list'', ''list_client'']');
insert into groupes_droits values (2,'Ecriture', '[''etabs.edit_etab'', ''etabs.del_etab'', ''etabs.add_etab'', ''etabs.import_etab'', ''etabs.add_type'', ''etabs.del_type'', ''services.del_service_installe'', ''services.add_service'', ''services.del_service'', ''services.add_service_installe'', ''services.edit_service'', ''serveurs.del_serveur'', ''serveurs.conf_ssh'', ''serveurs.edit_serveur'', ''serveurs.add_serveur'', ''serveurs.del_log'', ''serveurs.add_files'', ''serveurs.set_serveur_perms'', ''serveurs.del_serveur_perms'', ''modules.set_variante_perms'', ''modules.del_variante_perms'', ''serveurs.del_files'', ''serveurs.groupe_extend'', ''modules.del_module'', ''modules.del_mod_dict'', ''modules.del_variante'', ''modules.add_variante'', ''modules.copy_variante'', ''modules.edit_module'', ''modules.save_dico'', ''modules.edit_variante'', ''modules.add_module'', ''modules.add_files'', ''modules.del_files'', ''modules.import_variante'', ''prelude.get_managers'', ''prelude.register_server'', ''prelude.register_logger'', ''serveurs.migrate_serveur'', ''serveurs.migrate_data'', ''serveurs.migrate_conf'', ''serveurs.revert_migration'', ''serveurs.regen_key'']');
insert into groupes_droits values (3,'Configuration et actions sur les serveurs', '[''serveurs.save_conf'', ''serveurs.save_bastion'', ''serveurs.save_bastion_groupe'', ''serveurs.copy_conf'', ''serveurs.copy_perms'', ''serveurs.set_groupe_var'', ''serveurs.groupe_params'', ''serveurs.get_groupe_vars'', ''serveurs.maj_locks'', ''uucp.reconfigure'', ''uucp.install_variante'', ''uucp.configure'', ''uucp.confirm_transfer'', ''uucp.configure_groupe'', ''uucp.service_restart'', ''uucp.service_restart_groupe'', ''uucp.save_conf_groupe'', ''uucp.log_serveur'', ''uucp.maj_site'', ''uucp.maj_groupe'', ''uucp.reboot_groupe'',  ''uucp.reboot'', ''uucp.release_lock'', ''uucp.release_lock_groupe'', ''uucp.save_files'', ''uucp.install_module'', ''uucp.maj'', ''uucp.save_conf'',''uucp.purge_actions'',''uucp.maj_client'',''uucp.maj_client_groupe'']');
insert into groupes_droits values (4,'Gestion des permissions', '[''get_permissions'', ''save_permissions'',''get_user'',''get_rights'',''user_group'',''serveurs.authorize_user'',''serveurs.deny_user'', ''get_restrictions'', ''add_restriction'', ''del_restriction'', ''serveurs.save_group'',''modules.add_module'',''modules.update_modules'',''modules.edit_module'',''etabs.add_type'',''uucp.install_module'',''del_user'',''list_users'', ''update_client'', ''remove_client'']');
insert into groupes_droits values (5,'Fonction des clients','[''uucp.confirm_transfer'', ''uucp.get_checksum'',''uucp.maj_site'',''uucp.log_serveur'',''uucp.save_files'',''uucp.scan_timeouts'',''uucp.unlock'',''serveurs.get_locks'',''maj_client'', ''serveurs.get_timeout'', ''uucp.check_queue'', ''serveurs.update_key'', ''serveurs.get_key'']');
insert into groupes_droits values (6,'Export de variantes','[''modules.export_variante'',''modules.get_variante'']');
insert into groupes_droits values (7,'Configuration vpn','[''uucp.sphynx_add'', ''uucp.sphynx_del'', ''uucp.sphynx_get'']');
insert into groupes_droits values (8,'Enregistrement', '[''get_permissions'', ''maj_client'', ''serveurs.get_status'', ''serveurs.serveurs_etab'', ''serveurs.get_serveur'', ''serveurs.get_conf_uucp'', ''etabs.get_etab'', ''modules.get_module'', ''modules.get_variante'', ''uucp.configure'']');
insert into groupes_droits values (9,'Ajout/Modification de serveur (enregistrement)', '[''serveurs.add_serveur'', ''serveurs.edit_serveur'']');
/* XXX FIXME: fonctions prelude : à intégrer dans enregistrement ?? */
insert into groupes_droits values (10,'enregistrement des sondes prelude', '[''prelude.register_server'', ''prelude.get_managers'', ''prelude.register_logger'']');
insert into groupes_droits values (11,'Migration de serveur (enregistrement)', '[''serveurs.migrate_serveur'', ''serveurs.migrate_data'', ''serveurs.add_serveur'']');
/* droits d'ecriture limités */
insert into groupes_droits values (21,'Ecriture (serveurs)', '[''serveurs.del_serveur'', ''serveurs.conf_ssh'', ''serveurs.edit_serveur'', ''serveurs.add_serveur'', ''serveurs.del_log'', ''serveurs.add_files'', ''serveurs.set_serveur_perms'', ''serveurs.del_serveur_perms'',''serveurs.migrate_serveur'', ''serveurs.migrate_data'', ''serveurs.migrate_conf'', ''serveurs.revert_migration'', ''serveurs.groupe_extend'', ''serveurs.regen_key'']');
insert into groupes_droits values (22,'Ecriture (modules)', '[''modules.del_module'', ''modules.del_mod_dict'', ''modules.del_variante'', ''modules.add_variante'', ''modules.copy_variante'', ''modules.edit_module'', ''modules.edit_variante'', ''modules.add_module'', ''modules.add_files'', ''modules.del_files'', ''modules.import_variante'', ''modules.save_dico'', ''modules.set_variante_perms'', ''modules.del_variante_perms'']');
insert into groupes_droits values (23,'Ecriture (etablissements)', '[''etabs.edit_etab'', ''etabs.del_etab'', ''etabs.add_etab'', ''etabs.import_etab'', ''etabs.add_type'', ''etabs.del_type'']');
/* actions sans modification de configuration */
insert into groupes_droits values (31,'Actions sans modification de configuration', '[''uucp.reconfigure'', ''uucp.configure'', ''uucp.confirm_transfer'', ''uucp.configure_groupe'', ''uucp.service_restart'', ''uucp.service_restart_groupe'', ''uucp.log_serveur'', ''uucp.maj_groupe'', ''uucp.reboot_groupe'',  ''uucp.reboot'', ''uucp.release_lock'', ''uucp.release_lock_groupe'', ''uucp.maj'',''uucp.purge_actions'',''uucp.maj_client'',''uucp.maj_client_groupe'']');


/**********************************************/
/* Création des types de procédures blocables */
/**********************************************/

create table procedures (
  tag		varchar(20)	PRIMARY KEY,
  libelle 	varchar(100)
);
create table lock_serveur (
  id_serveur	integer		not null,
  tag			varchar(20)		not null,
  FOREIGN KEY(id_serveur)	REFERENCES serveurs(id) ON DELETE CASCADE,
  FOREIGN KEY(tag)			REFERENCES procedures(tag) ON DELETE CASCADE
);
insert into procedures values ('MAJ','Mise à jour (réseau ou cd)');
insert into procedures values ('RECONFIGURE','Reconfiguration du serveur');
insert into procedures values ('INSTANCE','Instanciation du serveur');

/****************************/
/* tables de gestion du vpn */
/****************************/

create table conf_vpn (
  id_sphynx     integer not null,
  id_amon       integer not null,
  etat          integer,
  FOREIGN KEY(id_sphynx)        REFERENCES serveurs(id) ON DELETE CASCADE,
  FOREIGN KEY(id_amon)          REFERENCES serveurs(id) ON DELETE CASCADE,
  PRIMARY KEY(id_sphynx,id_amon)
);

/**********************************************************************/
/* version light de la table de log (seulement un log de chaque type) */
/**********************************************************************/

create table last_log_serveur (
  id		serial			PRIMARY KEY,
  id_serveur	integer		not null,
  date		timestamp		not null,
  type		varchar(20),
  message	varchar(150)	not null,
  etat		integer			not null,
  FOREIGN KEY(id_serveur) REFERENCES serveurs(id) ON DELETE CASCADE
);

/***********************************************/
/* Table de restriction d'accès aux ressources */
/***********************************************/

create table restrictions (
  login		varchar(40)	not null,
  type_res	varchar(20)	not null,
  id_res	varchar(50)	not null,
  FOREIGN KEY(login) REFERENCES users(login) ON DELETE CASCADE
);

/*****************************************************************************/
/* Table de correspondance des variantes copiées à l'upgrade de distribution */
/*****************************************************************************/

create table migration_variantes (
  id_source	integer		not null,
  id_dest	integer		not null,
  FOREIGN KEY(id_source) REFERENCES variantes(id) ON DELETE CASCADE,
  FOREIGN KEY(id_dest) REFERENCES variantes(id) ON DELETE CASCADE
);

/*************************************************************/
/* augmentation de la taille de certains champs              */
/* (nb de serveurs dans un groupe, groupes de fonctions,...) */
/*************************************************************/

BEGIN;
ALTER TABLE serveurs ALTER COLUMN params TYPE varchar(1500);
ALTER TABLE serveurs ALTER COLUMN processeur TYPE varchar(100);
ALTER TABLE serveurs ALTER COLUMN libelle TYPE varchar(100);
COMMIT;
BEGIN;
ALTER TABLE groupes_serveurs ALTER COLUMN serveurs TYPE varchar(1500);
ALTER TABLE users ALTER COLUMN groupes TYPE varchar(200);
COMMIT;
BEGIN;
ALTER TABLE log_serveur ALTER COLUMN message TYPE varchar(300);
ALTER TABLE last_log_serveur ALTER COLUMN message TYPE varchar(300);
COMMIT;

/****************************************/
/* passage du champs ville en majuscule */
/****************************************/

UPDATE etablissements set ville=UPPER(ville);

/*******************************************/
/* Modifications sur les tables existantes */
/*******************************************/

BEGIN;
ALTER TABLE modules ADD COLUMN version integer;
ALTER TABLE modules ALTER COLUMN version set default 3;
COMMIT;
BEGIN;
ALTER TABLE serveurs ADD COLUMN maj integer;
COMMIT;
ALTER TABLE serveurs ADD COLUMN md5s integer;
COMMIT;

/*********************/
/* ajout des indexes */
/*********************/

create index log_id_index ON log_serveur(id_serveur);
create index last_log_type_index ON last_log_serveur(type);
create index last_log_date_index ON last_log_serveur(date);
create index serveurs_rne_index ON serveurs(rne);
create index serveurs_module_index ON serveurs(module_actuel);
create index serveur_etat_index ON serveurs(etat);
create index serveur_timeout_index ON serveurs(timeout);
create index variante_module_index ON variantes(module);

