#!/bin/bash
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# upgrade_zephir.sh
#  
# script de mise à jour de la base de données zephir
#       
###########################################################################
PG_DATA_DIR=/var/lib/postgres
PG_SERVICE=postgresql-8.2

# 1. se mettre en mode sans mot de passe
mv -f $PG_DATA_DIR/pg_hba.conf $PG_DATA_DIR/pg_hba.conf.savezephir
echo -e "local\tall\tall\ttrust" > $PG_DATA_DIR/pg_hba.conf
chown postgres.postgres $PG_DATA_DIR/pg_hba.conf
chmod 600 $PG_DATA_DIR/pg_hba.conf
/etc/init.d/$PG_SERVICE restart
sleep 1
# on regénère le mot de passe
/usr/share/eole/gen_pwd.py

su postgres <<EOF
psql -d zephir -Uzephir -f /usr/share/zephir/sql/maj.sql
EOF
sleep 1
# 5. se remettre en mode mot de passe
rm -f $PG_DATA_DIR/pg_hba.conf
mv -f $PG_DATA_DIR/pg_hba.conf.savezephir $PG_DATA_DIR/pg_hba.conf
chown postgres.postgres $PG_DATA_DIR/pg_hba.conf
chmod 600 $PG_DATA_DIR/pg_hba.conf
/etc/init.d/$PG_SERVICE restart
